﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class ImageUpload : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (IsPostBack && FileUpload1.HasFile && CheckBox1.Checked)
        {
            System.Configuration.Configuration rootWebConfig =
                System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("~/Final");
            String myConnString =
                rootWebConfig.ConnectionStrings.ConnectionStrings["ConnectionString"].ToString();
            SqlConnection myConn = new SqlConnection(myConnString);
            myConn.Open();
            /* Begin transaction here
             */
            SqlTransaction myTrans = myConn.BeginTransaction();

            int imageID = 0;
            try
            {
                SqlCommand myQuery = new SqlCommand("SELECT claimID FROM claim WHERE reference=@reference", myConn);
                myQuery.Transaction = myTrans;
                myQuery.Parameters.AddWithValue("@reference", TextBox1.Text);
                SqlDataReader myDR;
                myDR = myQuery.ExecuteReader();
                if (!myDR.Read())
                {
                    Label1.Text = "Invalid claim reference";
                    return;
                } 
                int claimID = myDR.GetInt32(0);
                myDR.Close();

                SqlCommand myInsert = new SqlCommand("INSERT INTO image VALUES(@title,@description,@claimID)", myConn);
                myInsert.Transaction = myTrans;
                myInsert.Parameters.AddWithValue("@title", TextBox2.Text);
                myInsert.Parameters.AddWithValue("@description", TextBox3.Text);
                myInsert.Parameters.AddWithValue("@claimID", claimID);
                int rows = myInsert.ExecuteNonQuery();
                if (rows != 1) throw new Exception("Unexpected Result for Insert");

                SqlCommand myCount = new SqlCommand("SELECT MAX(imageID) AS IMAGEID FROM image", myConn);
                myCount.Transaction = myTrans;
                myDR = myCount.ExecuteReader();
                myDR.Read();
                imageID = myDR.GetInt32(0);
                myDR.Close();
                /* Close transaction here -- success
                 */
                myTrans.Commit();
            }
            catch (Exception myEx)
            {
                /* Close transaction here -- failure
                 */
                myTrans.Rollback();
                Label1.Text = "Upload failed";
                return;
            }
            /* Note that the upload itself should also be included in the scope
             * of the transaction -- but this is not possible -- as the file
             * system does not support this
             */
            String path = Server.MapPath("~/Uploads/");
            try
            {
                String fileName = path + imageID.ToString() + ".jpg";
                FileUpload1.PostedFile.SaveAs(fileName);
                /* Create thumbnail as well
                 */
                System.Drawing.Image fullImage = System.Drawing.Image.FromFile(fileName);
                System.Drawing.Image thumb = new System.Drawing.Bitmap(fullImage, 100, 100);
                String thumbName = path + "thumb" + imageID.ToString() + ".jpg";
                thumb.Save(thumbName, fullImage.RawFormat);
                /* Assume save was successful
                 */
                Label1.Text = "Upload successful";
            }
            catch(Exception myEx)
            {
                Label1.Text = "Upload failed";
            }
        }
    }
}
